searchNodes=[{"type":"module","title":"Ark","doc":"Ark is a collection of small utilities useful for prototyping, testing, and working with Elixir common patterns. Utilities Ark.Drip This module allows to throttle calls to a shared resource with a simple broker process. Ark.Error This module provides function to work errors as data. Ark.Ok This module provides base functions to work with ok/error tuples. Ark.PipeIn This module provides a macro to set a variable from the end of a pipe. use Ark.PipeIn :val |&gt; Atom . to_string ( ) |&gt; String . upcase ( ) ~&gt; my_value IO . inspect ( my_value , label : &quot;my_value&quot; ) # my_value: &quot;VAL&quot; Ark.StructAccess This module provides a simple way to implement the Access behaviour for any struct. Example iex&gt; defmodule MyStruct do ...&gt; defstruct k : nil ...&gt; use Ark.StructAccess ...&gt; end iex&gt; s = % MyStruct { k : 1 } iex&gt; put_in ( s . k , 2 ) % MyStruct { k : 2 }","ref":"Ark.html"},{"type":"module","title":"Ark.BinarySearch","doc":"","ref":"Ark.BinarySearch.html"},{"type":"function","title":"Ark.BinarySearch.search/1","doc":"","ref":"Ark.BinarySearch.html#search/1"},{"type":"function","title":"Ark.BinarySearch.search/3","doc":"","ref":"Ark.BinarySearch.html#search/3"},{"type":"module","title":"Ark.Drip","doc":"","ref":"Ark.Drip.html"},{"type":"function","title":"Ark.Drip.await/2","doc":"","ref":"Ark.Drip.html#await/2"},{"type":"function","title":"Ark.Drip.cancel/2","doc":"","ref":"Ark.Drip.html#cancel/2"},{"type":"function","title":"Ark.Drip.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Ark.Drip.html#child_spec/1"},{"type":"function","title":"Ark.Drip.now_ms/0","doc":"","ref":"Ark.Drip.html#now_ms/0"},{"type":"function","title":"Ark.Drip.start/1","doc":"","ref":"Ark.Drip.html#start/1"},{"type":"function","title":"Ark.Drip.start_link/1","doc":"","ref":"Ark.Drip.html#start_link/1"},{"type":"function","title":"Ark.Drip.stop/1","doc":"","ref":"Ark.Drip.html#stop/1"},{"type":"module","title":"Ark.Drip.Bucket","doc":"","ref":"Ark.Drip.Bucket.html"},{"type":"function","title":"Ark.Drip.Bucket.drop/2","doc":"","ref":"Ark.Drip.Bucket.html#drop/2"},{"type":"function","title":"Ark.Drip.Bucket.new_ok/1","doc":"","ref":"Ark.Drip.Bucket.html#new_ok/1"},{"type":"function","title":"Ark.Drip.Bucket.new_ok/2","doc":"","ref":"Ark.Drip.Bucket.html#new_ok/2"},{"type":"function","title":"Ark.Drip.Bucket.next_refill!/1","doc":"","ref":"Ark.Drip.Bucket.html#next_refill!/1"},{"type":"module","title":"Ark.Drip.S","doc":"","ref":"Ark.Drip.S.html"},{"type":"module","title":"Ark.Error","doc":"","ref":"Ark.Error.html"},{"type":"macro","title":"Ark.Error.debug_error/2","doc":"","ref":"Ark.Error.html#debug_error/2"},{"type":"function","title":"Ark.Error.format_fallback/3","doc":"","ref":"Ark.Error.html#format_fallback/3"},{"type":"macro","title":"Ark.Error.log_error/2","doc":"","ref":"Ark.Error.html#log_error/2"},{"type":"macro","title":"Ark.Error.reason/2","doc":"","ref":"Ark.Error.html#reason/2"},{"type":"function","title":"Ark.Error.to_iodata/1","doc":"","ref":"Ark.Error.html#to_iodata/1"},{"type":"function","title":"Ark.Error.to_string/1","doc":"","ref":"Ark.Error.html#to_string/1"},{"type":"module","title":"Ark.Interface","doc":"","ref":"Ark.Interface.html"},{"type":"macro","title":"Ark.Interface.auto_impl/1","doc":"","ref":"Ark.Interface.html#auto_impl/1"},{"type":"macro","title":"Ark.Interface.definterface/2","doc":"","ref":"Ark.Interface.html#definterface/2"},{"type":"module","title":"Ark.Ok","doc":"","ref":"Ark.Ok.html"},{"type":"function","title":"Ark.Ok.map_ok/2","doc":"Mapping while ok. Takes an enumerable and applies the given callback to all values of the enumerable as long as the callback returns {:ok, mapped_value} . Stops when the callback returns {:error, term} and returns that tuple. Returns {:error, {:bad_return, {callback, [item]}, returned_value}} if the callback does not return a result tuple. Returns {:ok, mapped_values} or {:error, term}","ref":"Ark.Ok.html#map_ok/2"},{"type":"function","title":"Ark.Ok.ok/1","doc":"Wrapping ok. Converts a value to an :ok tuple, except when the value is: the single atom :ok or an :ok tuple the single atom :error or an :error tuple","ref":"Ark.Ok.html#ok/1"},{"type":"function","title":"Ark.Ok.ok?/1","doc":"Questionning ok. Returns true if the value is an {:ok, val} tuple or the single atom :ok . Returns false otherwise.","ref":"Ark.Ok.html#ok?/1"},{"type":"function","title":"Ark.Ok.reduce_ok/3","doc":"Reducing while ok. Takes an enumerable, an initial value for the accumulator and a reducer function. Calls the reducer for each value in the enumerable as long as the reducer returns {:ok, new_acc} . Stops when the reducer returns {:error, term} and returns that tuple. Returns {:error, {:bad_return, {reducer, [item, acc]}, returned_value}} if the reducer does not return a result tuple.","ref":"Ark.Ok.html#reduce_ok/3"},{"type":"function","title":"Ark.Ok.uok/1","doc":"Unwrapping ok. Unwraps an {:ok, val} tuple, giving only the value, returning anything else as-is. Does not unwrap {:error, ...} tuples. This function should not be used as it leads to ambiguous code where errors are still wrapped in tuples but values are &quot;naked&quot;. A case pattern matching on that type would be very unusual in Elixir/Erlang. Match on the original value or use uok!/1 .","ref":"Ark.Ok.html#uok/1"},{"type":"function","title":"Ark.Ok.uok!/1","doc":"Unwrapping ok with raise. Unwraps an {:ok, val} tuple, giving only the value, or returns the single :ok atom as-is. Raises with any other value.","ref":"Ark.Ok.html#uok!/1"},{"type":"function","title":"Ark.Ok.wok/1","doc":"wok is an alias of wrapping function :ok .","ref":"Ark.Ok.html#wok/1"},{"type":"macro","title":"Ark.Ok.xok!/1","doc":"Unwrapping ok, raising custom exceptions. Much like uok!/1 but if an :error 2-tuple contains any exception as the second element, that exception will be raised. Other values will lead to a generic Ark.Ok.UnwrapError exception to be reaised.","ref":"Ark.Ok.html#xok!/1"},{"type":"module","title":"Ark.PipeIn","doc":"","ref":"Ark.PipeIn.html"},{"type":"macro","title":"Ark.PipeIn.~>/2","doc":"","ref":"Ark.PipeIn.html#~%3E/2"},{"type":"module","title":"Ark.PubSub","doc":"","ref":"Ark.PubSub.html"},{"type":"function","title":"Ark.PubSub.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Ark.PubSub.html#child_spec/1"},{"type":"function","title":"Ark.PubSub.clear/2","doc":"","ref":"Ark.PubSub.html#clear/2"},{"type":"function","title":"Ark.PubSub.publish/3","doc":"","ref":"Ark.PubSub.html#publish/3"},{"type":"function","title":"Ark.PubSub.start/1","doc":"","ref":"Ark.PubSub.html#start/1"},{"type":"function","title":"Ark.PubSub.start_link/1","doc":"","ref":"Ark.PubSub.html#start_link/1"},{"type":"function","title":"Ark.PubSub.subscribe/3","doc":"","ref":"Ark.PubSub.html#subscribe/3"},{"type":"function","title":"Ark.PubSub.subscribe/4","doc":"","ref":"Ark.PubSub.html#subscribe/4"},{"type":"function","title":"Ark.PubSub.unsubscribe/3","doc":"","ref":"Ark.PubSub.html#unsubscribe/3"},{"type":"module","title":"Ark.StructAccess","doc":"","ref":"Ark.StructAccess.html"},{"type":"macro","title":"Ark.StructAccess.__using__/1","doc":"Using this module will allow to use the access macros and functions ( Kernel.get_in/2 , Kernel.put_in/2 , etc. ) with a struct.","ref":"Ark.StructAccess.html#__using__/1"},{"type":"exception","title":"Ark.Ok.UnwrapError","doc":"","ref":"Ark.Ok.UnwrapError.html"},{"type":"function","title":"Ark.Ok.UnwrapError.message/1","doc":"Callback implementation for Exception.message/1 .","ref":"Ark.Ok.UnwrapError.html#message/1"}]